#!/usr/bin/env python
from numpy import *
from matplotlib.pyplot import *


f = lambda x: 1.0/(1.0 + x**2)
g = lambda x: 0.5*f(5*x) + f(5*x+5)

l = -1.0
r = 1.0

a = linspace(l, r, 10**3)


##################
# Teilaufgabe a) #
##################

N = 21

#######################################################
# TODO: Interpolation mit einem Polynom pn vom Grad N #
#       auf N+1 aequidistanten Punkten.               #
#######################################################


figure()
plot(a, g(a), label=r"Original $g(a)$")
######################################################
# TODO: Plotten Sie das Interpolationspolynom pn(a). #
######################################################
grid(True)
xlim(l, r)
ylim(-2, 2)
legend(loc='lower center', framealpha=0.8)
title('Aequidistant interpolation points')
savefig("interpolation_aequidistant.png")


##################
# Teilaufgabe b) #
##################

############################################################
# TODO: Interpolation mit optimalen Interpolationspunkten. #
############################################################

err = 0.0
print("Maximaler absoluter Fehler:")
print(err)


figure()
plot(a, g(a), label=r"Original $g(a)$")
##################################################
# TODO: Plotten Sie den optimalen Interpolanden. #
##################################################
grid(True)
xlim(l, r)
ylim(-2, 2)
legend(loc='lower center', framealpha=0.8)
title('Optimal interpolation points')
savefig("interpolation_chebyshev.png")


##################
# Teilaufgabe c) #
##################

theta = 1e-3

#################################################################
# TODO: Bestimmen Sie die minimale Anzahl Interpolationspunkte, #
#       so dass der maximale Fehler in a kleiner als theta ist. #
#################################################################


##################
# Teilaufgabe d) #
##################

I_exact = 0.6721696847788537

# Original Integrand
Ix = lambda x: g(x)**2 / sqrt(1.0 - x**2)

###################################################
# TODO: Implementieren Sie als It(t) den geeignet #
#       transformierten Integranden.              #
#                                                 #
#It = lambda t: ...                               #
###################################################


M = arange(11, 152, 10)

##################################################
# TODO: Berechnen Sie das Integral mit It(t) und #
#       der Trapezregel fuer obige M.            #
##################################################


figure()
###################################################
# TODO: Plotten Sie den absoluten Fehler gegen M. #
###################################################
grid(True)
xlim(M.min(), M.max())
legend(loc='upper right', framealpha=0.8)
xlabel(r"$M$")
ylabel(r"Error $|I_{\mathrm{trapez}} - I_{\mathrm{exact}}|$")
savefig("quadrature_trapez.png")


##################################################
# TODO: Berechnen Sie das Integral mit Ix(x) und #
#       der Mittelpunktsregel fuer obige M.      #
##################################################


figure()
###################################################
# TODO: Plotten Sie den absoluten Fehler gegen M. #
###################################################
grid(True)
xlim(M.min(), M.max())
legend(loc='upper right', framealpha=0.8)
xlabel(r"$M$")
ylabel(r"Error $|I_{\mathrm{midpoint}} - I_{\mathrm{exact}}|$")
savefig("quadrature_midpoint.png")


##################
# Teilaufgabe e) #
##################

from chebnodesexp import chebexp

N = arange(10, 101, 10)

################################################################
# TODO: Berechnen Sie, fuer pN den optimalen Interpolanden aus #
#       Teilaufgabe b), das Integral I(pN) effizient.          #
#       Berechnen Sie dann fuer obige N den absoluten Fehler.  #
################################################################


figure()
###################################################
# TODO: Plotten Sie den absoluten Fehler gegen N. #
###################################################
grid(True)
xlim(N.min(), N.max())
legend(loc='upper right', framealpha=0.8)
xlabel(r"$N$")
ylabel(r"Error $|I_{\mathrm{chebyshev}} - I_{\mathrm{exact}}|$")
savefig("quadrature_efficient.png")
